/*
 *   kgoodstuff - a button bar a la FvwmButtons for KDE
 *   Copyright (C) 1998  Juergen Vigna
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef PreferencesButton_included
#define PreferencesButton_included

#include <kiconloaderdialog.h>
#include <drag.h>
#include <kurl.h>

#include "prefbuttondata.h"

class PreferencesButton : public PreferencesButtonData
{
    Q_OBJECT

public:

    PreferencesButton(QWidget* parent = NULL,const char* name = NULL);
    PreferencesButton(KIconLoader *il, QWidget* parent = NULL,
                      const char* name = NULL);
    ~PreferencesButton();
    void setPrefs(const char *bName, const char *bPixmap, const char *bCommand,
                  const char *bDesc, const char *bSwallowName,
                  const char *bSwallowCmd, bool childFlag, bool childCOptFlag,
                  int useRows, int useCols);
    const char *getButtonName();
    const char *getButtonPixmap();
    const char *getButtonCommand();
    const char *getButtonDesc();
    const char *getButtonSwallowName();
    const char *getButtonSwallowCmd();
    bool getButtonChildKGS();
    bool getButtonChildCloseOpt();
    int getButtonUseRows();
    int getButtonUseCols();
    QButton *pokButton;
    void *data;
    KDNDDropZone *kdndWidget;

protected slots:
    void okButtonCB();
    void applyButtonCB();
    void slotDropEvent(KDNDDropZone * dz);

protected:
    void init(KIconLoader *il);
    void setPos(QLabel *lab, QLineEdit *le);

signals:
    void okButtonPressed();

private:
    KIconLoaderButton
        *ilb;
    KIconLoader
        *lil;
};
#endif // PreferencesButton_included
